SystemOrganization addCategory: #'SwaMC-Versioning'!

!MCVersion methodsFor: '*SwaMC-actions-override' stamp: 'tfel 6/14/2011 14:16:00.217'!
load
	
	MCVersionLoader withAllSubclasses
		select: [:subclass | subclass isRefinementFor: MCVersionLoader]
		thenDo: [:subclass | subclass loadVersion: self].! !

!MCVersion methodsFor: '*SwaMC-actions-override' stamp: 'tfel 6/14/2011 14:16:33.129'!
merge

	MCVersionMerger withAllSubclasses
		select: [:subclass | subclass isRefinementFor: MCVersionMerger]
		thenDo: [:subclass | subclass mergeVersion: self].
! !

!MCVersion methodsFor: '*SwaMC-accessing' stamp: 'tfel 6/16/2011 13:18:21.75'!
refinements 

	^ MCRefinementHolder for: self package name, self info id asString! !

!MCMczWriter class methodsFor: '*SwaMC-actions' stamp: 'tfel 6/14/2011 14:59:15.894'!
fileOut: aVersion onZip: aZip

	self subclassResponsibility! !

!MCMczWriter methodsFor: '*SwaMC-visiting-override' stamp: 'tfel 6/14/2011 14:21:48.132'!
writeVersion: aVersion
	self writeFormat.
	self writePackage: aVersion package.
	self writeVersionInfo: aVersion info.
	self writeDefinitions: aVersion.
	self class allSubclasses
		select: [:subclass | subclass isRefinementFor: self class]
		thenDo: [:subclass | subclass fileOut: aVersion onZip: zip].
	aVersion dependencies do: [:ea | self writeVersionDependency: ea].! !

Object subclass: #MCRefinementHolder
	instanceVariableNames: ''
	classVariableNames: 'Refinements'
	poolDictionaries: ''
	category: 'SwaMC-Versioning'!

!MCRefinementHolder class methodsFor: 'accessing' stamp: 'tfel 7/8/2011 10:11:13.453'!
for: aVersion

	^ Refinements at: aVersion ifAbsentPut: [Dictionary new]! !

!MCRefinementHolder class methodsFor: 'class initialization' stamp: 'fb 6/16/2011 13:33:47.13'!
initialize

	super initialize.
	Refinements := Dictionary new.! !

!MCMczReader class methodsFor: '*SwaMC-actions' stamp: 'tfel 6/14/2011 14:57:12.52'!
refineVersion: aVersion fromZip: aZip

	self subclassResponsibility.	! !

!MCMczReader methodsFor: '*SwaMC-accessing' stamp: 'tfel 6/14/2011 17:46:09.456'!
basicVersion
	| version |
	version := super basicVersion.
	self class allSubclasses
		select: [:subclass | subclass isRefinementFor: self class]
		thenDo: [:subclass | subclass refineVersion: version fromZip: self zip].
	^ version! !

!MCWriter class methodsFor: '*SwaMC' stamp: 'tfel 6/14/2011 14:17:42.586'!
isRefinementFor: aClass

	^ aClass == self! !

!MCVersionLoader class methodsFor: '*SwaMC' stamp: 'tfel 6/14/2011 14:17:15.895'!
isRefinementFor: aClass

	^ aClass == self! !

!MCVersionMerger class methodsFor: '*SwaMC' stamp: 'tfel 6/14/2011 14:16:58.285'!
isRefinementFor: aClass

	^ aClass == self! !

!MCReader class methodsFor: '*SwaMC' stamp: 'tfel 6/14/2011 14:17:36.448'!
isRefinementFor: aClass

	^ aClass == self! !
MCRefinementHolder initialize!
